#!/usr/local/bin/perl
#------------------------------------------------------
# mixi Diary Writer Ver.1.0.0
#            Copyright (C) DonaDona(KITAO Masato) 2004
#------------------------------------------------------
use     strict;
use     DBI;
use     Jcode;
use     File::Basename;
use     Getopt::Std;
require WWW::Mixi;

my $VERSION        = "1.0.0";
my $mixi;
my $loginUser      = '';
my $loginPassword  = '';

# ץ
my $txt_dir        = ".";           # θоݤȤǥ쥯ȥ
my $touch_file     = 'touch.txt';   # ǽ¸ե
my $config_file    = 'config.txt';  # ID/PWʤɤꤷƤե
my $newFile_id     = 'new';         # ƤȸʤեID
my $delete_title   = 'delete';      # оݤȤ륿ȥ
my $draft_title    = 'draft';       # ư륿ȥ
my $schedule_title = 'schedule';    # (ޤư)

# С饤¦ʸɻ
# (mixiФeucʤΤǡ¦eucˤ뤳)
my $client_encoding = 'sjis';
my $server_encoding = 'euc';

# Command Line Optionsμ
$Getopt::Std::STANDARD_HELP_VERSION = 1;
getopts('u:p:c:dq');

# Configեμ
$config_file = $Getopt::Std::opt_c if $Getopt::Std::opt_c;
&load_config() if -e($config_file);

# ѥ᡼
my $debug       = ($Getopt::Std::opt_d ? $Getopt::Std::opt_d : 0); # ǥХå⡼
my $quiet       = ($Getopt::Std::opt_q ? $Getopt::Std::opt_q : 0); # ̵(quiet)⡼
unless($loginUser){
  $loginUser = ($Getopt::Std::opt_u ne '' ? $Getopt::Std::opt_u : &input_prompt('e-mail'));
}
unless($loginPassword){
  $loginPassword  = ($Getopt::Std::opt_p ne '' ? $Getopt::Std::opt_p : &input_prompt('password'));
}

# 
$mixi = WWW::Mixi->new($loginUser, $loginPassword);
&main();
exit(0);

# СɽGetOptsƤӽФ)
sub VERSION_MESSAGE {
    print <<"EOD";
mixi Diary Writer Version $VERSION
Copyright (C) DonaDona(KITAO Masato) 2004

based by
-Hatena Diary Writer(by Hiroshi Yuki)
 http://www.hyuki.com/techinfo/hatena_diary_writer.html
-WWW::Mixi(by TSUKAMOTO Makio)
 http://digit.que.ne.jp/work/?Perl%a5%e2%a5%b8%a5%e5%a1%bc%a5%eb%2fWWW%3a%3aMixi
EOD
}

# إɽGetOptsƤӽФ)
sub HELP_MESSAGE {
    print <<"EOD";
Usage: perl $0 [Options]

Options:
    --version       Show version.
    --help          Show this message.
    -d              Debug. Use this switch for verbose log.
    -q              Quiet. Use this switch for no log.
    -u username     MailAddress for Login
    -p password     Password. Specify password.
EOD
}

# 
sub main {
  # оݤȤʤեȹѤ߷
  my @files;
  my $count = 0;
  
  # ǥ쥯ȥΥեǽ⿷ΤꥹȤɲäƤ
  while (glob("$txt_dir/*.txt")) {
    next if (-e($touch_file) and (-M($_) > -M($touch_file)));
    push(@files, $_);
  }
  for my $file (@files) {
    # ե̾ˤäƽ֤򿷵⡼ɤ⡼ɤȽꤹ롣
    # Ǥʤϡθ˿ʤࡣ
    my $diary_id = '';
    if ($file =~ /\b(\d\d\d\d)-(\d\d)-(\d\d)_(\d+)\.txt$/){
      $diary_id = $4;
    }
    elsif ($file =~ /(\b|_)($newFile_id\d*)\.txt$/){
      $diary_id = $2;
    }
    else{
      next;
    }
    # ⤽줬եǤ뤫ɤȽꤹ롣㤨Хåס
    next unless (-f $file);
    
    # եɤ߹ߡȥʬΥ롣
    my ($title, $body) = read_title_body($file);
    
    # ե̾_13.jpgե򸡺ꥹȤɲäƤ
    my @imgfiles = find_image_file($file);

    if ($title eq $draft_title) {
      # оݤȤʤ륿ȥǤϥåפ롣
      next;
    }
    else {
      # ޤ(ư)ƥå
      if ($title =~ /^$schedule_title:(\d{8,14}):(.*)$/) {
        if(substr("${1}000000", 0, 14) > &get_timestamp){
          next;
        }
        $title = $2;
      }
      if ($title eq $delete_title && !($diary_id  =~ /^$newFile_id\d*$/)) {
        # оݤȤʤ륿ȥȤƤꡢƤΤΤǤʤС롣
        $count += &delete_entry($diary_id);
      }
      else{
        # Ƥ⤷Խ
        $count += &create_update_entry($file, $diary_id, $title, $body, @imgfiles);
      }
    }
    sleep(1);
  }
  
  # Touch file.
  if($count > 0){
    open(FILE, "> $touch_file") or die "$!:$touch_file\n";
    print FILE &get_timestamp;
    close(FILE);
  }
  else{
    print_message("оݤȤʤϤޤǤ");
  }
}

# ϥץץ
sub input_prompt($){
  my $temp = '';
  print "@_: ";
  chomp($temp  = <STDIN>);
  return $temp;
}

# ǥХåѥåɽ
sub print_debug(@) {
  if ($debug) {
    print "DEBUG: ", Jcode::convert(@_, $client_encoding), "\n";
  }
}

# ̾åɽQuiet⡼ɰʳ
sub print_message(@) {
  unless($quiet){
    print Jcode::convert(@_, $client_encoding), "\n";
  }
}

# 顼åɽλ
sub error_exit(@) {
    print "ERROR: ", @_, "\n";
    exit(1);
}

# եɤ߼ꡢܤ򥿥ȥ롢ʹߤιԤʸȤ֤
sub read_title_body($) {
  my ($file) = @_;

  my $input = $file;
  print_debug("read_title_body: input: $input");
  if (not open(FILE, $input)) {
    error_exit("$!:$input");
  }
  my $title = <FILE>; # first line.
  chomp($title);
  my $body = join('', <FILE>); # rest of all.
  close(FILE);

  if($client_encoding ne $server_encoding) {
    print_debug("Convert from $client_encoding to $server_encoding.");
    $title = Jcode::convert($title, $server_encoding, $client_encoding);
    $body  = Jcode::convert($body,  $server_encoding, $client_encoding);
  }
  return($title, $body);
}

# Ƥ
sub create_update_entry($$$$@) {
  my ($file, $diary_id, $title, $body, @imgfiles) = @_;

  # 󤷤ƤʤС󤹤롣
  if(!$mixi->is_logined){
    $mixi->login;
  }
  # 
  my $error = '';
  my %diary = (
    'diary_title' => $title,
    'diary_body'  => $body,
    );
  my $result = 0;
  my $postLabel = '';
  
  foreach my $imgfile(@imgfiles){
    if ($imgfile =~ /_([1-3]{1})\.jpg$/){
      $diary{"photo$1"} = $imgfile;
    }
  }
  
  if($diary_id =~ /^$newFile_id\d*$/){
    $postLabel = '';
    $result = $mixi->get_add_diary_confirm(%diary);
  }
  else{
    $postLabel = 'Խ';
    $diary{'diary_id'} = $diary_id;
    $result = $mixi->get_edit_diary_confirm(%diary);
  }
  if($result){
    print_message("[${postLabel}] $title");
    if($diary_id =~ /^$newFile_id\d*$/){
      my $item = get_top_diary();
      my $newFilename = "$item->{'year'}-$item->{'month'}-$item->{'day'}_$item->{'diary_id'}.txt";
      rename $file, "$txt_dir/$newFilename";
      print_message(" -> $newFilename ˥͡वޤ");
      
      foreach my $imgfile(@imgfiles){
        if ($imgfile =~ /_([1-3]{1})\.jpg$/){
          my $newImgfile = "$item->{'year'}-$item->{'month'}-$item->{'day'}_$item->{'id'}_$1.jpg";
          rename $imgfile, "$txt_dir/$newImgfile";
          print_message(" -> $newImgfile ˥͡वޤ");
        }
      }
    }
    return 1;
  }
  else{
    print_message("[${postLabel}] $title");
    return 0;
  }
}

# 
sub delete_entry($) {
  my ($diary_id) = @_;
  my %diary = (
    'diary_id'  => $diary_id,
    );
  # 󤷤ƤʤС󤷡¹Ԥ롣
  if(!$mixi->is_logined){
    $mixi->login;
  }
  if($mixi->get_delete_diary_confirm(%diary)){
    print_message("[λ] $diary_id");
    return 1;
  }
  else{
    print_message("[] $diary_id");
    return 0;
  }
}

# ƤID
sub get_top_diary {
  my $res     = $mixi->get('list_diary.pl');
  my $content = $res->content;
  my ($year, $month, $day, $hour, $minute, $id) = (0, 0, 0, 0, 0, 0, 0);
  if($content =~ /<td.*?><a HREF=".*?" CLASS=wide><img .*?>(\d{4})ǯ(\d{2})ΰ<\/a><\/td>/i){
    $year = $1;
  }
  if($content =~ /<td ALIGN=center ROWSPAN=3 NOWRAP bgcolor=\#F2DDB7><font COLOR=\#996600>(\d{2})(\d{2})<br>(\d{2}):(\d{2})<\/font><\/td>/i){
    ($month, $day, $hour, $minute) = ($1, $2, $3, $4);
  }
  if($content =~ /<a href="edit_diary.pl\?id=(\d+?)">.*<\/a>/i){
    $id = $1;
  }
  my $item = {
    'year'     => $year,
    'month'    => $month,
    'day'      => $day,
    'hour'     => $hour,
    'minute'   => $minute,
    'diary_id' => $id
    };
  return $item;
}

# ॹפμtouch_filescheduleʤɤѡ
sub get_timestamp() {
    my (@week) = qw(Sun Mon Tue Wed Thu Fri Sat);
    my ($sec, $min, $hour, $day, $mon, $year, $weekday) = localtime(time);
    $year += 1900;
    $mon++;
    $mon  = "0$mon"  if $mon < 10;
    $day  = "0$day"  if $day < 10;
    $hour = "0$hour" if $hour < 10;
    $min  = "0$min"  if $min < 10;
    $sec  = "0$sec"  if $sec < 10;
    $weekday = $week[$weekday];
    return "$year$mon$day$hour$min$sec";
}

# ե¸ߤ򸡺ꥹȤ֤
sub find_image_file($) {
  my @imgfiles;
  my ($fulltxt) = @_;
  my ($base, $path, $type) = fileparse($fulltxt, qr/\.txt/);
  for(my $i = 1; $i <= 3; $i++){
    my $imgfile = "$path${base}_$i.jpg";
    if (-e $imgfile) {
      if (-e($touch_file) and (-M($imgfile) > -M($touch_file))) {
        print_debug("find_image_file: skip $imgfile (not updated).");
        next;
      }
      else {
        print_debug("find_image_file: $imgfile");
        push(@imgfiles, $imgfile);
      }
    }
  }
  return @imgfiles;
}

# configեɤ߽Ф
sub load_config() {
  print_debug("Loading config file ($config_file).");
  if (not open(CONF, $config_file)) {
    error_exit("Can't open $config_file.");
  }
  while (<CONF>) {
    chomp;
    if (/^\#/) {
      # skip comment.
    }
    elsif (/^$/) {
      # skip blank line.
    }
    elsif (/^id:([^:]+)$/) {
      $loginUser = $1;
      print_debug("load_config: id:$loginUser");
    }
    elsif (/^password:(.*)$/) {
      $loginPassword = $1;
      print_debug("load_config: password:********");
    }
    elsif (/^client_encoding:(.*)$/) {
      $client_encoding = $1;
      print_debug("load_config: client_encoding:$client_encoding");
    }
    elsif (/^server_encoding:(.*)$/) {
      $server_encoding = $1;
      print_debug("load_config: server_encoding:$server_encoding");
    }
    elsif (/^txt_dir:(.*)$/) {
      $txt_dir = glob($1);
      print_debug("load_config: txt_dir:$txt_dir");
    }
    elsif (/^touch:(.*)$/) {
      $touch_file = glob($1);
      print_debug("load_config: touch:$touch_file");
    }
    elsif (/^schedule:(.*)$/) {
      $schedule_title = $1;
      print_debug("load_config: schedule:$schedule_title");
    }
    else {
      error_exit("Unknown command '$_' in $config_file.");
    }
  }
  close(CONF);
}
__END__
#WWW::mixi Ver.0.19б
#Ȥִ
#create_update_entry(), delete_entry()˥᥽å
#schedule:yyyymmdd:deleteʤԶ
#-q⡼ɤɲ
